#pragma once
#ifndef __WBFZAlgComponetXmlParaseOperator_H__
#define __WBFZAlgComponetXmlParaseOperator_H__
#include <QObject>
#include <QString>
#include <QFileDialog>
#include <QMessageBox>
#include <QDebug>
#include <QtXml>
#include <QFile>
#include <QTextStream>
#include <QDomDocument>
#include <QDomElement>
#include <QDomNode>
#include <QDomNodeList>
#include <QDomText>
#include <QDomNamedNodeMap>
#include <QDomAttr>
#include <QDomEntity>
#include <QDomEntityReference>
#include "KJ135WBJYAlgWidgetComponet.h" // 㷨


// 㷨xml
class WBFZAlgComponetXmlParamenterItem :QObject
{
	Q_OBJECT
public:
	WBFZAlgComponetXmlParamenterItem(QDomElement* itemparameter,QObject* parent=nullptr);
	~WBFZAlgComponetXmlParamenterItem();
private:
	QString ParaName; // 
	QString ParaChsName;// 
	QString Description;// 

	QString Datatype;//   Value // 
	QString ParaType;//   string

	QString ValueStr;

public:
	//  getset 
	QString getParaName() const;
	void setParaName(const QString& name);
	QString getParaChsName() const;
	void setParaChsName(const QString& name);
	QString getDescription() const;
	void setDescription(const QString& description);
	QString getDatatype() const;
	void setDatatype(const QString& datatype);
	QString getParaType() const;
	void setParaType(const QString& type);
	QString getValueStr() const;
	void setValueStr(const QString& value);

};

// 㷨xml
class WBFZAlgComponetXmlParaseOperator :QObject
{
	Q_OBJECT
public:
	WBFZAlgComponetXmlParaseOperator(QObject* parent = nullptr);
	~WBFZAlgComponetXmlParaseOperator();
	void loadXmlFile(const QString& fileName);

	void writeXmlFile(const QString& formatfilepath, QString outfilepath,QString workspace, QMap<QString, QString> inputParamslist);



private:
	void parseXmlFile();
	void displayParsedData();

private:
	QString workSpacePath;
	QString xmlFilePath;
private:// ļṹ
	QDomDocument doc; // xmlĵ
	QDomElement rootElement; // ڵ
	QDomElement workSpaceElement; // ռڵ
	QList<WBFZAlgComponetXmlParamenterItem*> ParameterList; // б

public:
	QString getWorkSpacePath() const;// { return this->workSpacePath; } // ȡռ·
	void setWorkSpacePath(const QString& path);// { this->workSpacePath = path; } // ùռ·
	QList<WBFZAlgComponetXmlParamenterItem*> getParameterList() const; // { return this->ParameterList; } // ȡб
	void setParameterList(const QList<WBFZAlgComponetXmlParamenterItem*>& list); //{ this->ParameterList = list; } // òб


};



#endif// __WBFZAlgComponetXmlParaseOperator_H__

