#include "QWBFZExcuteAlgProgramDialog.h"
#include "ui_QWBFZExcuteAlgProgramDialog.h"
#include "KJ135WBJYAlgWidgetComponet.h"
#include <QProcess>
#include <qt_windows.h>  

QWBFZExcuteAlgProgramDialog::QWBFZExcuteAlgProgramDialog(QWidget *parent)
	: QDialog(parent),
	ui(new Ui::QWBFZExcuteAlgProgramDialogClass),
	xmlfileSelectWidget(new FileSelectWidget(this)),
	exefileSelectWidget(new FileSelectWidget(this))
{
	ui->setupUi(this);

	// Ӳѡ
	exefileSelectWidget->setParaName(u8"㷨ִexe");
	exefileSelectWidget->setParaChsName(u8"㷨ִexe");
	exefileSelectWidget->setDescription(u8"㷨ִexe");
	exefileSelectWidget->setDatatype(u8"string");
	exefileSelectWidget->setParaType(u8"Value");
	exefileSelectWidget->setComponentType(ComponentType::FileSelect);
	exefileSelectWidget->initUI();

	xmlfileSelectWidget->setParaName(u8"㷨xmlļ");
	xmlfileSelectWidget->setParaChsName(u8"㷨xmlļ");
	xmlfileSelectWidget->setDescription(u8"㷨xmlļ");
	xmlfileSelectWidget->setDatatype(u8"string");
	xmlfileSelectWidget->setParaType(u8"Value");
	xmlfileSelectWidget->setComponentType(ComponentType::FileSelect);
	xmlfileSelectWidget->initUI();


	ui->verticalLayout_InParamsRegion->addWidget(exefileSelectWidget);
	ui->verticalLayout_InParamsRegion->addWidget(xmlfileSelectWidget);

	// źŲ
	QObject::connect(ui->buttonBox, SIGNAL(accepted()), this, SLOT(onacceptButton_Clicked()));
	QObject::connect(ui->buttonBox, SIGNAL(rejected()), this, SLOT(oncancelButton_Clicked()));
	this->show();
}

QWBFZExcuteAlgProgramDialog::~QWBFZExcuteAlgProgramDialog()
{
	delete ui;
}

void QWBFZExcuteAlgProgramDialog::onacceptButton_Clicked()
{
	QString xmlfilepath = xmlfileSelectWidget->getValue();
	QString exefilepath = exefileSelectWidget->getValue();

	qDebug() <<"xmlpath :\t" << xmlfilepath;
	qDebug() << "exepath :\t" << exefilepath;

	// ȡexeļļ·
	QString exeDirPath = QFileInfo(exefilepath).absolutePath();
	qDebug() << "exedirpath :\t" << exeDirPath;
	
	// cmdȽexeļĿ¼ȻִexeļΪxmlļ·
	QString cmdstr = QString("cd /d %1 && %2 %3").arg(exeDirPath).arg(exefilepath).arg(xmlfilepath);
	qDebug() << "cmdstr :\t" << cmdstr;
	// ִcmd
	QProcess* process = new QProcess(this);
	process->setProcessChannelMode(QProcess::MergedChannels);

 
	// Windows APIǿƵ
	process->setCreateProcessArgumentsModifier([](QProcess::CreateProcessArguments* args) {
		args->flags |= CREATE_NEW_CONSOLE;  // ¿̨
		args->startupInfo->wShowWindow = SW_SHOWNORMAL;  // ʾ
		args->startupInfo->dwFlags &= ~STARTF_USESTDHANDLES;  // ñ׼ض[3,7](@ref)
		});


	// ʵʱȡ
	connect(process, &QProcess::readyRead, [=]() {
		QString output = QString::fromLocal8Bit(process->readAll());
		qDebug() << "CMD Output:" << output;
		});

	// ó·Ͳ
	process->start("cmd.exe", QStringList() << "/k" << cmdstr);

	// 
	connect(process, &QProcess::errorOccurred, [](QProcess::ProcessError error) {
		qDebug() << "Error:" << error;
		});

}

void QWBFZExcuteAlgProgramDialog::oncancelButton_Clicked()
{
	this->close();
}
